SystemOrganization addCategory: #'Voyage-Mongo-Magritte'!

Trait named: #TVOMongoManyRelation
	uses: {}
	category: 'Voyage-Mongo-Magritte'!

!TVOMongoManyRelation classSide methodsFor: 'defaults' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
defaultKindCollection 
	^OrderedCollection! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
kindCollection 
	^self 
		propertyAt: #kindCollection 
		ifAbsent: [ self class defaultKindCollection ]! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
kindCollection: aClass 
	self 
		propertyAt: #kindCollection 
		put: aClass! !

MADescriptionBuilder subclass: #VOMongoDescriptionBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:53'!
build: aClass
	| pragmas explicitDescriptions inferedDescriptions containerPragmas explicitContainer |
	
	containerPragmas := Pragma allNamed: #mongoContainer in: aClass theMetaClass.
	containerPragmas size > 1 
		ifTrue: [ self error: 'More than one container definition!!' ].
	explicitContainer := containerPragmas 
		ifNotEmpty: [ self buildContainer: containerPragmas anyOne in: aClass ]
		ifEmpty: [ self buildInferedContainer: aClass ].
	
	pragmas := Pragma allNamed: #mongoDescription: in: aClass theMetaClass.
	explicitDescriptions := pragmas collect: [ :each | self build: each in: aClass ].
	inferedDescriptions := (aClass allInstVarNames 
		copyWithoutAll: (explicitDescriptions collect: #attributeName))
		collect: [ :each | self buildInfered: each ]. 

	^explicitContainer 
		addAll: explicitDescriptions;
		addAll: inferedDescriptions;
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:51'!
build: aPragma in: aClass
	| description |
	description := (aPragma method valueWithReceiver: aClass arguments: #())
		attributeName: (aPragma argumentAt: 1);
		yourself.
	
	(description accessor isKindOf: MANullAccessor) 
		ifTrue: [ description accessor: (self buildDirectAccessorFor: (aPragma argumentAt: 1)) ].  
	
	^description! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:52'!
buildContainer: aPragma in: aClass
	| description |
	description := aPragma method valueWithReceiver: aClass arguments: #().
	
	description collectionName isEmptyOrNil 
		ifTrue: [ description collectionName: (self collectionNameFor: aClass) ].
	
	^description! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:49'!
buildDirectAccessorFor: aString
	^MAPluggableAccessor 
		read: [ :anObject | anObject instVarNamed: aString ]
		write: [ :anObject :value | anObject instVarNamed: aString put: value ]! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:49'!
buildInfered: aString
	^VOMongoAttributeDescription new
		attributeName: aString;
		accessor: (self buildDirectAccessorFor: aString);
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:53'!
buildInferedContainer: aClass
	^VOMongoContainer new 
		collectionName: (self collectionNameFor: aClass);
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:52'!
collectionNameFor: aClass
	^(aClass name asString allButFirst: 2) asLegalSelector! !

MAVisitor subclass: #VOMongoVisitor
	instanceVariableNames: 'repository json object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoVisitor subclass: #VOMongoMaterializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoMaterializer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/29/2011 09:46'!
materialize: anObject fromJSON: aDictionary
	^self 
		materialize: anObject 
		fromJSON:  aDictionary 
		description: (self repository descriptionBuilder for: anObject class)
	! !

!VOMongoMaterializer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/29/2011 09:46'!
materialize: anObject fromJSON: aDictionary description: aDescription
	| oldObject oldJSON |
	
	oldObject := self object.
	oldJSON := self json.
	[  
	  self object: anObject.
	  self json: aDictionary.
	  self visit: aDescription.
	  ^self object ]
	ensure: [ 
		self object: oldObject.
		self json: oldJSON ]! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:05'!
visitAttributeDescription: aDescription 
	self object 
		write: (self jsonAt: aDescription mongoName) 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 14:46'!
visitToManyEmbededDescription: aDescription
	| plainElements elements |
	
	plainElements := self jsonAt: aDescription mongoName.
	plainElements ifNotNil: [
		elements := (plainElements as: aDescription kindCollection) 
			collect: [ :each | 
				self 
					materialize: aDescription kind basicNew
					fromJSON: each ] ].
	
	self object 
		write: elements 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 13:32'!
visitToManyReferenceDescription: aDescription
	| plainElements elements |
	
	plainElements := self jsonAt: aDescription mongoName.
	plainElements ifNotNil: [
		elements := ((plainElements as: aDescription kindCollection) 
			collect: [ :each | 
				aDescription isLazy 
					ifTrue: [
						LazyProxy objectClass: aDescription kind id: (each at: '__id') ]
					ifFalse: [ 
						self repository 
							selectOne: aDescription kind 
							where: (Dictionary with: '_id'->(each at: '__id'))] ]) ].
	
	self object 
		write: elements 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 10:02'!
visitToOneEmbededDescription: aDescription
	self object 
		write: ((self jsonAt: aDescription mongoName)
			ifNotNil: [ :embededDictionary | 
				self 
					materialize: aDescription kind basicNew
					fromJSON: embededDictionary ])	
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:35'!
visitToOneReferenceDescription: aDescription
	| element |
	
	element := (self jsonAt: aDescription mongoName) ifNotNil: [ :reference | 
		aDescription isLazy 
			ifTrue: [ 
				LazyProxy objectClass: aDescription kind id: (reference at: '__id') ]
			ifFalse: [ 
				self repository 
					selectOne: aDescription kind 
					where: (Dictionary with: '_id'->(reference at: '__id')) ] ].
	
	self object 
		write: element 
		using: aDescription! !

VOMongoVisitor subclass: #VOMongoSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoSerializer methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 14:38'!
keyOf: anObject 
	^self repository 
		keyOf: anObject
		ifAbsent: [ VOMongoError signal: 'Invalid reference' ]! !

!VOMongoSerializer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/28/2011 22:00'!
serialize: anObject
	^self 
		serialize: anObject 
		description: (self repository descriptionBuilder for: anObject class)
	! !

!VOMongoSerializer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/29/2011 08:56'!
serialize: anObject description: aDescription
	| oldObject oldJSON |
	
	oldObject := self object.
	oldJSON := self json.
	[  
	  self object: anObject.
	  self json: Dictionary new.
	  self visit: aDescription.
	  ^self json ]
	ensure: [ 
		self object: oldObject.
		self json: oldJSON ]! !

!VOMongoSerializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 22:02'!
visitAttributeDescription: aDescription 
	self 
		jsonAt: aDescription mongoName 
		put: (self object readUsing: aDescription)! !

!VOMongoSerializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 13:23'!
visitToManyEmbededDescription: aDescription
	| elements |
	
	elements := (self object readUsing: aDescription) 
		ifNotNil: [ :objects | (objects collect: [ :each | self serialize: each ]) asArray ].
	
	self 
		jsonAt: aDescription mongoName 
		put: elements! !

!VOMongoSerializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 14:38'!
visitToManyReferenceDescription: aDescription
	| elements |
	
	elements := (self object readUsing: aDescription) 
		ifNotNil: [ :objects |
			(objects collect: [ :each | Dictionary with: '__id'->(self keyOf: each) ]) asArray ].
	
	self 
		jsonAt: aDescription mongoName 
		put: elements! !

!VOMongoSerializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 12/13/2011 01:07'!
visitToOneEmbededDescription: aDescription
	| element |
	
	element := (self object readUsing: aDescription)
		ifNotNil: [ :embededObject | self serialize: embededObject  ].
	
	self 
		jsonAt: aDescription mongoName 
		put: element! !

!VOMongoSerializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/29/2011 14:39'!
visitToOneReferenceDescription: aDescription
	| element |
	
	element := (self object readUsing: aDescription) 
		ifNotNil: [ :reference | Dictionary with: '__id' -> (self keyOf: reference) ].
	
	self 
		jsonAt: aDescription mongoName 
		put: element! !

!VOMongoVisitor class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 10/28/2011 22:14'!
repository: aRepository
	^self basicNew 
		initialize: aRepository;
		yourself! !

!VOMongoVisitor methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/27/2011 16:16'!
initialize: aRepository
	repository := aRepository.
	self initialize! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
json
	^ json! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
json: anObject
	json := anObject! !

!VOMongoVisitor methodsFor: 'private' stamp: 'EstebanLorenzano 11/7/2011 14:52'!
jsonAt: aString 
	^self json 
		at: aString
		ifAbsent: [ nil ]! !

!VOMongoVisitor methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
jsonAt: aString put: anObject
	self json at: aString put: anObject! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
object
	^ object! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
object: anObject
	object := anObject! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 16:16'!
repository
	^repository! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
visitAttributeDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitContainer: aDescription
	aDescription do: [ :each |
		each acceptMagritte: self ] ! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitToManyEmbededDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:17'!
visitToManyReferenceDescription: aDescription aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 11:36'!
visitToOneEmbededDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitTransientDescription: aDescription! !

MAContainer subclass: #VOMongoContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoContainer class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/29/2011 15:55'!
defaultCollectionName 
	^(self label allButFirst: 2) asLegalSelector! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/29/2011 15:42'!
collectionName 
	^self 
		propertyAt: #collectionName
		ifAbsent: [ self class defaultCollectionName ]! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/29/2011 15:43'!
collectionName: aString
	self 
		propertyAt: #collectionName
		put: aString! !

MADescription subclass: #VOMongoDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoDescription subclass: #VOMongoAttributeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoAttributeDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 15:42'!
isAbstract 
	^false! !

!VOMongoAttributeDescription methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/27/2011 15:39'!
acceptMagritte: aVisitor
	aVisitor visitAttributeDescription: self.! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 14:53'!
attributeName
	^self 
		propertyAt: #attributeName
		ifAbsent: [ nil ]! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
attributeName: aString
	self 
		propertyAt: #attributeName
		put: aString! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
mongoName 
	^self 
		propertyAt: #mongoName 
		ifAbsent: [ self attributeName ]! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
mongoName: aString 
	self 
		propertyAt: #mongoName 
		put: aString! !

!VOMongoDescription methodsFor: 'printing' stamp: 'EstebanLorenzano 10/27/2011 14:54'!
printOn: aStream
	aStream nextPutAll: self attributeName! !

VOMongoDescription subclass: #VOMongoRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoRelationDescription subclass: #VOMongoEmbededDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoEmbededDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
isAbstract 
	^false! !

VOMongoEmbededDescription subclass: #VOMongoToManyEmbededDescription
	uses: TVOMongoManyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoToManyEmbededDescription class
	uses: TVOMongoManyRelation classTrait
	instanceVariableNames: ''!

!VOMongoToManyEmbededDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
acceptMagritte: aVisitor
	aVisitor visitToManyEmbededDescription: self.! !

VOMongoEmbededDescription subclass: #VOMongoToOneEmbededDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoToOneEmbededDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 11:36'!
acceptMagritte: aVisitor
	aVisitor visitToOneEmbededDescription: self.! !

VOMongoRelationDescription subclass: #VOMongoReferenceDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoReferenceDescription class methodsFor: 'defaults' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
defaultLazy 
	^false! !

!VOMongoReferenceDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 16:14'!
isAbstract 
	^false! !

!VOMongoReferenceDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
beEager 
	self 
		propertyAt: #lazy 
		put: false! !

!VOMongoReferenceDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:30'!
beLazy 
	self 
		propertyAt: #lazy 
		put: true! !

!VOMongoReferenceDescription methodsFor: 'testing' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
isEager
	^self isLazy not! !

!VOMongoReferenceDescription methodsFor: 'testing' stamp: 'EstebanLorenzano 10/28/2011 12:30'!
isLazy 
	^self 
		propertyAt: #lazy 
		ifAbsent: [ self class defaultLazy ]! !

VOMongoReferenceDescription subclass: #VOMongoToManyReferenceDescription
	uses: TVOMongoManyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoToManyReferenceDescription class
	uses: TVOMongoManyRelation classTrait
	instanceVariableNames: ''!

!VOMongoToManyReferenceDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:15'!
acceptMagritte: aVisitor 
	aVisitor visitToManyReferenceDescription: self! !

VOMongoReferenceDescription subclass: #VOMongoToOneReferenceDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoToOneReferenceDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:15'!
acceptMagritte: aVisitor 
	aVisitor visitToOneReferenceDescription: self! !

VOMongoDescription subclass: #VOMongoTransientDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoTransientDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
isAbstract 
	^false! !

!VOMongoTransientDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
acceptMagritte: aVisitor 
	aVisitor visitTransientDescription: self! !
